#!/usr/bin/env expectk

set control_e "\x05"

frame .b
button .b.b1  -text "Attach"		-command {exp_send "${control_e}ca" }
button .b.b2  -text "Flow Control"	-command {exp_send "${control_e}cc" }
button .b.b3  -text "Disconnect"	-command {exp_send "${control_e}c."
						  exit}
button .b.b4  -text "Down"		-command {exp_send "${control_e}cd" }
button .b.b5  -text "Force"		-command {exp_send "${control_e}cf" }
button .b.b6  -text "Group"		-command {exp_send "${control_e}cg" }
button .b.b7  -text "Host Status"	-command {exp_send "${control_e}cu" }
button .b.b8  -text "Version"		-command {exp_send "${control_e}cv" }
button .b.b9 -text "Who"		-command {exp_send "${control_e}cw" }
button .b.b10 -text "Send Break"	-command {exp_send "${control_e}cl1" }
button .b.b11 -text "Spy Mode"		-command {exp_send "${control_e}cs" }
button .b.b12 -text "Replay"		-command {exp_send "${control_e}cr"}
button .b.b13 -text "Help"		-command {exp_send "${control_e}c?"}
button .b.b14 -text "Log"		-command {start_logging}
button .b.b15 -text "StopLog"		-command {stop_logging}

frame .f

scrollbar .f.sb -command {.f.t yview}
text .f.t -yscrollcommand {.f.sb set}
pack .f.t -side left -fill both -expand 1
pack .f.sb -fill y  -side left

for {set i 1} {$i < 16} {incr i} {
     grid configure .b.b$i -row [expr "int($i / 8)"] -column [expr $i % 8]
}

pack .f -side bottom -expand 1 -fill both
pack .b -side bottom -expand 1 -fill both

set logging 0

proc sendchars { string } {
    global sent_buf logging sent_last


    if {"$string" != "" } {
	exp_send -- $string
        puts "sent |$string|"
	set sent_buf "$sent_buf$sent_last"
	set sent_last $string
	flush_rcvd
    }
}

proc rcvchars { string } {
    global sent_buf rcvd_buf logging sent_last

    puts "rcvchars |$string|"
    if { "$string" == "$sent_last" } {
	# echo-ed chars, ignore
    } else {
        .f.t insert end $string
	set rcvd_buf "$rcvd_buf$string"
	flush_sent
    }
}

proc start_logging {} {
     global sent_buf sent_last rcvd_buf logging log_fd sent_last
     if { ! $logging} {
	 set log_fd [open "logfile" "w"]
	 set sent_buf {}
	 set sent_last {}
	 set rcvd_buf {}
	 set logging 1
     }
}

proc stop_logging {} {
     global sent_buf rcvd_buf logging log_fd sent_last
     if {$logging} {
	 flush_sent
	 flush_rcvd
	 close $log_fd
	 set logging 0
     }
}

proc flush_rcvd {} {
     global sent_buf rcvd_buf logging log_fd sent_last
     if {"$rcvd_buf" != ""} {
	 if { $logging } {
	     set toprint [list expect $rcvd_buf]
	     regsub -all "\r" $toprint {\\r} toprint
	     puts $log_fd $toprint
	 }
	 set rcvd_buf {}
     }
}

proc flush_sent {} {
     global sent_buf sent_buf logging log_fd sent_last
     if {$logging && ("$sent_buf" != "" || "$sent_last" != "") } {
	 set toprint [list exp_send "$sent_buf$sent_last" ]
         regsub -all "\r" $toprint {\\r} toprint
	 puts $log_fd $toprint
     }
     set sent_buf {}
     set sent_last {}
}

spawn sh

bind .f.t <KeyPress> 	{}
bind .f.t <KeyRelease> 	{sendchars "%A"}

set sent_buf {}
set sent_last {}
set rcvd_buf {}
set logging 0

expect {
    -re {.+} {rcvchars $expect_out(0,string); exp_continue }
    timeout  {flush_sent; flush_rcvd; exp_continue}
}
